//  ODBC API Tv

//  SQLAllocEnv
//  SQLFreeEnv
//  SQLDrivers
//  SQLDataSources

//  sqltypes.h / sql.h / sqlext.h

//  2006/12/30
//  BlueLeaf1336
//  http://www.geocities.jp/fjtkt/index.html

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

type
    USHORT          = Word;

    //  ODBCp^錾
    SQLSMALLINT     = SHORT;
    SQLRETURN       = SQLSMALLINT;
    SQLINTEGER      = Longint;
    SQLHANDLE       = SQLINTEGER;
    SQLHENV         = SQLHANDLE;
    SQLUSMALLINT    = USHORT;
    SQLPCHAR        = PChar;

const
    //  DLL
    odbc32 = 'odbc32.dll';

    //  return values from functions
    SQL_SUCCESS             = 0;
    SQL_SUCCESS_WITH_INFO   = 1;
    SQL_INVALID_HANDLE      = -2;
    SQL_ERROR               = -1;
    SQL_NO_DATA             = 100;
    SQL_NO_DATA_FOUND       = SQL_NO_DATA;

    //  SẴ\[XtFb`
    SQL_FETCH_NEXT          = 1;
    //  [U[\[X݂̂tFb`
    SQL_FETCH_FIRST_USER    = 31;
    //  VXe\[X݂̂tFb`
    SQL_FETCH_FIRST_SYSTEM  = 32;
    //  
    SQL_FETCH_FIRST         = 2;

    //  SQLDataSources()  BufferLength1 ɂ SQL_MAX_DSN_LENGTH+1 ŏ\
    SQL_MAX_DSN_LENGTH      = 32;

//  nhݒ肷
//  ߒlFSQL_SUCCESS, SQL_SUCCESS_WITH_INFO, SQL_INVALID_HANDLE, SQL_ERROR
function SQLAllocEnv(var EnvironmentHandle: SQLHENV): SQLRETURN;
    stdcall; external odbc32 name 'SQLAllocEnv';

//  nhJ
function SQLFreeEnv(EnvironmentHandle: SQLHENV): SQLRETURN;
    stdcall; external odbc32 name 'SQLFreeEnv';

//  hCo擾
//  ߒlFSQL_SUCCESS, SQL_SUCCESS_WITH_INFO, SQL_NO_DATA, SQL_ERROR, SQL_INVALID_HANDLE.
function SQLDrivers(
     EnvironmentHandle: SQLHENV;
     Direction: SQLUSMALLINT;
     DriverDescription: SQLPCHAR;
     BufferLength1: SQLSMALLINT;
     var DescriptionLengthPtr: SQLSMALLINT;
     DriverAttributes: SQLPCHAR;
     BufferLength2: SQLSMALLINT;
     var AttributesLengthPtr: SQLSMALLINT): SQLRETURN;
     stdcall; external odbc32 name 'SQLDrivers';

//  f[^\[X擾
//  ߒlFSQL_SUCCESS, SQL_SUCCESS_WITH_INFO, SQL_NO_DATA, SQL_ERROR, SQL_INVALID_HANDLE.
function SQLDataSources(
     EnvironmentHandle: SQLHENV;
     Direction: SQLUSMALLINT;
     ServerName: SQLPCHAR;
     BufferLength1: SQLSMALLINT;
     var NameLength1Ptr: SQLSMALLINT;
     Description: SQLPCHAR;
     BufferLength2: SQLSMALLINT;
     var NameLength2Ptr: SQLSMALLINT): SQLRETURN;
     stdcall; external odbc32 name 'SQLDataSources';

implementation

{$R *.dfm}

//-----------------------------------------------------------------------------
//  SQLDrivers()  DriverAttributes 𕶎ɕϊ
//  ) FileUsage=1\0FileExtns=*.dbf\0\0  FileUsage=1,FileExtns=*.dbf
function BreakList(const ANullTerminateText: array of Char): String;
var
    LStart: Integer;
    LBuffer: array[0..255] of Char;
    LText: String;
begin
    LStart := 0;
    LText := ANullTerminateText;
    Result := LText; 
    Inc(LStart, Length(LText) + 1);
    while (True) do
    begin
        FillChar(LBuffer, SizeOf(LBuffer), 0);
        Move(ANullTerminateText[LStart], LBuffer, SizeOf(LBuffer));
        LText := LBuffer;
        Inc(LStart, Length(LText) + 1);
        if (LText = '') then Break;
        Result := Result + ',' + AnsiQuotedStr(LText, '"');
    end;
end;

//-----------------------------------------------------------------------------
//  ODBC̃hCoXg擾
procedure TForm1.Button1Click(Sender: TObject);
const
    BUF_MAX = 1024;
var
    LEnvironmentHandle: SQLHENV;
    LDriverDescription: array[0..BUF_MAX] of Char;
    LDescriptionLengthPtr: SQLSMALLINT;
    LDriverAttributes: array[0..BUF_MAX] of Char;
    AttributesLengthPtr: SQLSMALLINT;
    LReturn: SQLRETURN;
    LText: String;
begin
    Memo1.Clear();

    try
        //  nhݒ
        if (SQLAllocEnv(LEnvironmentHandle) = SQL_ERROR) then Exit;

        try
            //  ŏ̃hCo擾
            FillChar(LDriverDescription, SizeOf(LDriverDescription), 0);
            FillChar(LDriverAttributes, SizeOf(LDriverAttributes), 0);

            LReturn := SQLDrivers(LEnvironmentHandle, SQL_FETCH_FIRST,
                 LDriverDescription, BUF_MAX + 1, LDescriptionLengthPtr,
                 LDriverAttributes, BUF_MAX + 1, AttributesLengthPtr);

            //  ȍ~̃hCo擾
            while (LReturn <> SQL_NO_DATA_FOUND) do
            begin
                //  ʏo
                //LText := String(LDriverDescription) + '/' + String(LDriverAttributes);
                LText := String(LDriverDescription) + '/' + BreakList(LDriverAttributes);
                Memo1.Lines.Add(LText);

                FillChar(LDriverDescription, SizeOf(LDriverDescription), 0);
                FillChar(LDriverAttributes, SizeOf(LDriverAttributes), 0);

                LReturn := SQLDrivers(LEnvironmentHandle, SQL_FETCH_NEXT,
                     LDriverDescription, BUF_MAX + 1, LDescriptionLengthPtr,
                     LDriverAttributes, BUF_MAX + 1, AttributesLengthPtr);
            end;

        finally
            //  nhJ
            SQLFreeEnv(LEnvironmentHandle);
        end;
    except
        on E:Exception do Memo1.Lines.Add(E.Message);
    end;
end;

//-----------------------------------------------------------------------------
//  ODBC̃f[^\[XXg擾
procedure TForm1.Button2Click(Sender: TObject);
const
    BUF_MAX = 1024;
var
    LEnvironmentHandle: SQLHENV;
    LServerName: array[0..SQL_MAX_DSN_LENGTH] of Char;
    LNameLength1Ptr: SQLSMALLINT;
    LDescription: array[0..BUF_MAX] of Char;
    LNameLength2Ptr: SQLSMALLINT;
    LReturn: SQLRETURN;
    LText: String;
begin
    Memo1.Clear();

    try
        //  nhݒ
        if (SQLAllocEnv(LEnvironmentHandle) = SQL_ERROR) then Exit;

        try
            //  ŏ̃hCo擾
            FillChar(LServerName, SizeOf(LServerName), 0);
            FillChar(LDescription, SizeOf(LDescription), 0);

            LReturn := SQLDataSources(LEnvironmentHandle, SQL_FETCH_FIRST,
                 LServerName, SQL_MAX_DSN_LENGTH + 1, LNameLength1Ptr,
                 LDescription, BUF_MAX + 1, LNameLength2Ptr);

            //  ȍ~̃hCo擾
            while (LReturn <> SQL_NO_DATA_FOUND) do
            begin
                //  ʏo
                //LText := String(LDriverDescription) + '/' + String(LDriverAttributes);
                LText := String(LServerName) + '/' + BreakList(LDescription);
                Memo1.Lines.Add(LText);

                FillChar(LServerName, SizeOf(LServerName), 0);
                FillChar(LDescription, SizeOf(LDescription), 0);

                LReturn := SQLDataSources(LEnvironmentHandle, SQL_FETCH_NEXT,
                     LServerName, SQL_MAX_DSN_LENGTH + 1, LNameLength1Ptr,
                     LDescription, BUF_MAX + 1, LNameLength2Ptr);
            end;

        finally
            //  nhJ
            SQLFreeEnv(LEnvironmentHandle);
        end;
    except
        on E:Exception do Memo1.Lines.Add(E.Message);
    end;
end;

end.
 